Subject: Re: [RFC Patch net-next] net_sched: make classifying lockless on ingress

From: John Fastabend <[email-masked]>
Date: Fri, 20 Dec 2013 18:32:49 -0800

On 12/20/2013 4:24 PM, Cong Wang wrote:
> On Fri, Dec 20, 2013 at 4:08 PM, Eric Dumazet <[email-masked]> wrote:
>> On Fri, 2013-12-20 at 15:57 -0800, Cong Wang wrote:
>>
>>> Just push the lock down to ->enqueue() ? Since ingress qdisc is classless
>>> and its ->dequeue() is nop.
>>
>>
>> https://github.com/jrfastab/Linux-Kernel-QOS
>>
>> https://github.com/jrfastab/Linux-Kernel-QOS/commit/67746f95acd77cf15d7ce34f644b76058ce19813
>>
>
> It's a nice idea to introduce a ->prequeue().
>
> And so brave to play with RCU on singly linked list... maybe I can
> just steal the ->prequeue() piece. John? :-D

If you only steal the prequeue piece then you don't solve the lock
contention part so I don't think it helps. At which point I suspect
you might as well use one of the existing qdiscs not designed for
multiqueue nics.

>
> BTW, the last commit is about 5 months ago...

Yeah well I imagined I would write a rate limiting qdisc to use
this infrastructure. Jamal hinted at using a systolic processes
for this. But I work on this when I have time and have been
busy the last few months with other things unfortunately.

> --
> To unsubscribe from this list: send the line "unsubscribe netdev" in
> the body of a message to [email-masked]
> More majordomo info at  http://vger.kernel.org/majordomo-info.html
>